#
# Poor man's XML parser
#

#
# xml.parse
#
# splits document into a long list, structured as a sequence of
# five elements
#
# All credit to Steve Ulher for his perversity.
#
namespace eval xml {
	proc cl x {return "\[$x\]"}

    variable formMap
	variable w " \t\r\n"	;# white space
	variable name [cl a-zA-Z_][cl -a-zA-Z0-9._]*
    variable alphanumeric	a-zA-Z0-9

    for {set i 1} {$i <= 256} {incr i} {
	set c [format %c $i]
	if {![string match \[$alphanumeric\] $c]} {
		set fmt %[format %.2x $i]
	    set formMap($c) $fmt
		set formMap($fmt) $c
	}
    }
    # These are handled specially
    array set formMap {
	" " +   \n %0d%0a
    }
}
#
# Wee prob, XML mandates case-insensitivity (Must check)
#
proc xml::putattrs {args} {
	variable formMap
	variable name
	set ret {}
	foreach {fld val} $args {
		regsub -all {([[\$\\])} $val {\\\1} val
		regsub -all {(["'/>])} $val {[set formMap(\\\1)]} val
		append ret "$fld=\\\"$val\\\" "
	}
	return [subst $ret]
}
proc xml::parse {xml} {
	variable w
	# Breaks if attr list contains / or >

	# Protect Tcl special characters
	regsub -all {([{}\\])} $xml {\\\1} xml

	set exp <(/?)([cl ^$w>]+)[cl $w]*([cl ^>/]*)(/?)>
	set sub "\}\n{\\2} {\\1} {\\4} {\\3} \{"

	regsub -all $exp $xml $sub xml
	return "{} {} {} {} \{$xml\}"
}
proc xml::getattrs {attrs} {
	variable alphanumeric
	variable formMap
    # First check whether there's any work to do
    if {![string compare {} [string trim $attrs]]} {
		return {}
    }

    # Protect Tcl special characters
    regsub -all {([[\$\\])} $attrs {\\\1} attrs

	# Is it really case-insensitive (XXX Must check)
    set ws "\n\t "
    regsub -all [format {([a-zA-Z0-9]+)[%s]*=[%s]*"([^"]*)"} $ws $ws] $attrs {[set parsed(\1) {\2}] } attrs ;# "
    regsub -all [format {([a-zA-Z0-9]+)[%s]*=[%s]*'([^']*)'} $ws $ws] $attrs {[set parsed(\1) {\2}] } attrs
    subst $attrs

	set ret {}
	foreach key [array names parsed] {
		regsub -all {%[0-9a-fA-F][0-9a-fA-F]} $parsed($key) {$formMap(&)} parsed($key)
		lappend ret $key [subst $parsed($key)]
	}
    return $ret
}
